/****************************************************************************************** 
 *	Chili DirectX Framework Version 12.04.24											  *	
 *	Game.cpp																			  *
 *	Copyright 2012 PlanetChili.net														  *
 *																						  *
 *	This file is part of The Chili DirectX Framework.									  *
 *																						  *
 *	The Chili DirectX Framework is free software: you can redistribute it and/or modify	  *
 *	it under the terms of the GNU General Public License as published by				  *
 *	the Free Software Foundation, either version 3 of the License, or					  *
 *	(at your option) any later version.													  *
 *																						  *
 *	The Chili DirectX Framework is distributed in the hope that it will be useful,		  *
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of						  *
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the						  *
 *	GNU General Public License for more details.										  *
 *																						  *
 *	You should have received a copy of the GNU General Public License					  *
 *	along with The Chili DirectX Framework.  If not, see <http://www.gnu.org/licenses/>.  *
 ******************************************************************************************/
#include "Game.h"
#include <math.h>

Game::Game( HWND hWnd,const KeyboardServer& kServer,const MouseServer& mServer )
:	gfx( hWnd ),
	audio( hWnd ),
	kbd( kServer ),
	mouse( mServer ),
	rotationAngle( 0.0f ),
	colchange ( 0 ),
	r (255),
	g (255),
	b( 255 )
{}

void Game::Go()
{
	//rotationAngle += 0.053f;
	rotationAngle += 0.53f;
	if( rotationAngle > 3.14159f * 50.0f )
	{
		rotationAngle -= 3.14159f * 2.0f;
	}

	gfx.BeginFrame();
	ComposeFrame();
	gfx.EndFrame();
}



void Game::Draw( float theta,int tx,int ty,int r,int g,int b )
{
	float cosVal = cos( theta );
	float sinVal = sin( theta );
	int x1 = 0;
	int y2 = 0;
	int col=1;
	int y1=-230;
	for (int x2=0; x2 < 250; x2=x2+10)
	{


		int rotx1 = x1 * cosVal - y1 * sinVal;
		int roty1 = x1 * sinVal + y1 * cosVal;
		int rotx2 = x2 * cosVal - y2 * sinVal;
		int roty2 = x2 * sinVal + y2 * cosVal;
		gfx.DrawLine(rotx1 + tx,roty1 + ty,rotx2 + tx,roty2 + ty,r,g,b);
		if (y1 < 0) y1=y1+10;
	}
	// Hieght
	y1=250;
	//across
	for (int x2=0; x2 < 250; x2=x2+10)
	{
		int rotx1 = x1 * cosVal - y1 * sinVal;
		int roty1 = x1 * sinVal + y1 * cosVal;
		int rotx2 = x2 * cosVal - y2 * sinVal;
		int roty2 = x2 * sinVal + y2 * cosVal;
		gfx.DrawLine(rotx1 + tx,roty1 + ty,rotx2 + tx,roty2 + ty,r,g,b);
		if (y1 > 0) y1=y1-10;
	}
	y1=250;
	//across
	for (int x2=0; x2 > -250; x2=x2-10)
	{
		int rotx1 = x1 * cosVal - y1 * sinVal;
		int roty1 = x1 * sinVal + y1 * cosVal;
		int rotx2 = x2 * cosVal - y2 * sinVal;
		int roty2 = x2 * sinVal + y2 * cosVal;
		gfx.DrawLine(rotx1 + tx,roty1 + ty,rotx2 + tx,roty2 + ty,r,g,b);
		if (y1 > 0) y1=y1-10;
	}
	y1=-230;
	for (int x2=0; x2 > -250; x2=x2-10)
	{
		int rotx1 = x1 * cosVal - y1 * sinVal;
		int roty1 = x1 * sinVal + y1 * cosVal;
		int rotx2 = x2 * cosVal - y2 * sinVal;
		int roty2 = x2 * sinVal + y2 * cosVal;
		gfx.DrawLine(rotx1 + tx,roty1 + ty,rotx2 + tx,roty2 + ty,r,g,b);
		if (y1 < 0) y1=y1+10;
	}
}

void Game::ComposeFrame()
{


	if (colchange>100)
	{
		r=(rand() % 255);
		g=(rand() % 255);
		b=(rand() % 255);
		colchange=0;
	}

	colchange++;
	Draw( rotationAngle,400,250,r,g,b );

}